# datacatalog-api
API Documentation for MINT Data Catalog

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.0.1
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import datacatalog 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import datacatalog
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import datacatalog
from datacatalog.rest import ApiException
from pprint import pprint


# Defining host is optional and default to https://api.mint-data-catalog.org
configuration.host = "https://api.mint-data-catalog.org"
# Create an instance of the API class
api_instance = datacatalog.DatasetsApi(datacatalog.ApiClient(configuration))
body = datacatalog.InlineObject3() # InlineObject3 | 

try:
    # List all resources for this dataset
    api_response = api_instance.dataset_resources(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DatasetsApi->dataset_resources: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.mint-data-catalog.org*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DatasetsApi* | [**dataset_resources**](docs/DatasetsApi.md#dataset_resources) | **POST** /datasets/dataset_resources | List all resources for this dataset
*DatasetsApi* | [**dataset_standard_variables**](docs/DatasetsApi.md#dataset_standard_variables) | **POST** /datasets/dataset_standard_variables | List all standard_variables for this dataset
*DatasetsApi* | [**dataset_variables**](docs/DatasetsApi.md#dataset_variables) | **POST** /datasets/dataset_variables | List all variables for this dataset
*DatasetsApi* | [**datasets_search**](docs/DatasetsApi.md#datasets_search) | **POST** /datasets/search | Full-text search of datasets
*DatasetsApi* | [**find_datasets**](docs/DatasetsApi.md#find_datasets) | **POST** /find_datasets | Search datasets by name, id, or standard variables
*DatasetsApi* | [**get_dataset_info**](docs/DatasetsApi.md#get_dataset_info) | **POST** /datasets/get_dataset_info | Detailed information about the dataset
*DatasetsApi* | [**register_datasets**](docs/DatasetsApi.md#register_datasets) | **POST** /datasets/register_datasets | Create dataset record(s)
*ResourcesApi* | [**get_resource_info**](docs/ResourcesApi.md#get_resource_info) | **POST** /resources/get_resource_info | Detailed information about the resource
*ResourcesApi* | [**register_resources**](docs/ResourcesApi.md#register_resources) | **POST** /datasets/register_resources | Create resource record(s)
*StandardVariablesApi* | [**get_standard_variable_info**](docs/StandardVariablesApi.md#get_standard_variable_info) | **POST** /standard_variables/get_standard_variable_info | Detailed information about the standard variable
*StandardVariablesApi* | [**register_standard_variables**](docs/StandardVariablesApi.md#register_standard_variables) | **POST** /knowledge_graph/register_standard_variables | Create standard_variable record(s)
*VariablesApi* | [**get_variable_info**](docs/VariablesApi.md#get_variable_info) | **POST** /variables/get_variable_info | Detailed information about the variable
*VariablesApi* | [**register_variables**](docs/VariablesApi.md#register_variables) | **POST** /datasets/register_variables | Create variable record(s)


## Documentation For Models

 - [Dataset](docs/Dataset.md)
 - [InlineObject](docs/InlineObject.md)
 - [InlineObject1](docs/InlineObject1.md)
 - [InlineObject10](docs/InlineObject10.md)
 - [InlineObject11](docs/InlineObject11.md)
 - [InlineObject12](docs/InlineObject12.md)
 - [InlineObject2](docs/InlineObject2.md)
 - [InlineObject3](docs/InlineObject3.md)
 - [InlineObject4](docs/InlineObject4.md)
 - [InlineObject5](docs/InlineObject5.md)
 - [InlineObject6](docs/InlineObject6.md)
 - [InlineObject7](docs/InlineObject7.md)
 - [InlineObject8](docs/InlineObject8.md)
 - [InlineObject9](docs/InlineObject9.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse2001Dataset](docs/InlineResponse2001Dataset.md)
 - [InlineResponse2001DatasetVariables](docs/InlineResponse2001DatasetVariables.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2002Dataset](docs/InlineResponse2002Dataset.md)
 - [InlineResponse2002DatasetResources](docs/InlineResponse2002DatasetResources.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2003Dataset](docs/InlineResponse2003Dataset.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2004Dataset](docs/InlineResponse2004Dataset.md)
 - [InlineResponse2004DatasetVariables](docs/InlineResponse2004DatasetVariables.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2005Dataset](docs/InlineResponse2005Dataset.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2006Dataset](docs/InlineResponse2006Dataset.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [InlineResponse2007Dataset](docs/InlineResponse2007Dataset.md)
 - [InlineResponse200Dataset](docs/InlineResponse200Dataset.md)
 - [InlineResponse200DatasetStandardVariables](docs/InlineResponse200DatasetStandardVariables.md)
 - [Provenance](docs/Provenance.md)
 - [Resource](docs/Resource.md)
 - [StandardVariable](docs/StandardVariable.md)
 - [Variable](docs/Variable.md)


## Documentation For Authorization

 All endpoints do not require authorization.

## Author

danf@usc.edu


