# coding: utf-8

"""
    MINT Data Catalog

    API Documentation for MINT Data Catalog  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: danf@usc.edu
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Dataset(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'provenance_id': 'str',
        'name': 'str',
        'description': 'str',
        'metadata': 'object'
    }

    attribute_map = {
        'id': 'id',
        'provenance_id': 'provenance_id',
        'name': 'name',
        'description': 'description',
        'metadata': 'metadata'
    }

    def __init__(self, id=None, provenance_id=None, name=None, description=None, metadata=None):  # noqa: E501
        """Dataset - a model defined in OpenAPI"""  # noqa: E501

        self._id = None
        self._provenance_id = None
        self._name = None
        self._description = None
        self._metadata = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.provenance_id = provenance_id
        self.name = name
        self.description = description
        if metadata is not None:
            self.metadata = metadata

    @property
    def id(self):
        """Gets the id of this Dataset.  # noqa: E501

        Unique identifier  # noqa: E501

        :return: The id of this Dataset.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Dataset.

        Unique identifier  # noqa: E501

        :param id: The id of this Dataset.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def provenance_id(self):
        """Gets the provenance_id of this Dataset.  # noqa: E501

        record_id of the entity that created this dataset  # noqa: E501

        :return: The provenance_id of this Dataset.  # noqa: E501
        :rtype: str
        """
        return self._provenance_id

    @provenance_id.setter
    def provenance_id(self, provenance_id):
        """Sets the provenance_id of this Dataset.

        record_id of the entity that created this dataset  # noqa: E501

        :param provenance_id: The provenance_id of this Dataset.  # noqa: E501
        :type: str
        """
        if provenance_id is None:
            raise ValueError("Invalid value for `provenance_id`, must not be `None`")  # noqa: E501

        self._provenance_id = provenance_id

    @property
    def name(self):
        """Gets the name of this Dataset.  # noqa: E501

        Display name/title of the dataset  # noqa: E501

        :return: The name of this Dataset.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Dataset.

        Display name/title of the dataset  # noqa: E501

        :param name: The name of this Dataset.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this Dataset.  # noqa: E501

        Human-readable description of the dataset  # noqa: E501

        :return: The description of this Dataset.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Dataset.

        Human-readable description of the dataset  # noqa: E501

        :param description: The description of this Dataset.  # noqa: E501
        :type: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def metadata(self):
        """Gets the metadata of this Dataset.  # noqa: E501


        :return: The metadata of this Dataset.  # noqa: E501
        :rtype: object
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Dataset.


        :param metadata: The metadata of this Dataset.  # noqa: E501
        :type: object
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Dataset):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
